{
  inputs = {
    naersk.url = "github:nix-community/naersk/master";
    nixpkgs.url = "github:NixOS/nixpkgs/nixpkgs-unstable";
    rust-overlay.url = "github:oxalica/rust-overlay";
    utils.url = "github:numtide/flake-utils";
  };

  outputs = { self, nixpkgs, rust-overlay, utils, naersk }:
    utils.lib.eachDefaultSystem (system:
      let
        pkgs = import nixpkgs { inherit system; };

        naersk-lib = pkgs.callPackage naersk {};
      in
      {
        packages = {
          default = naersk-lib.buildPackage {
            src = ./.;
            doCheck = true;
          };
          unix = naersk-lib.buildPackage {
            src = ./.;
            doCheck = true;
            cargoBuildOptions = x: x ++ ["--no-default-features" "--features" "unix"];
            cargoTestOptions  = x: x ++ ["--no-default-features" "--features" "unix"];
          };
          tcp = naersk-lib.buildPackage {
            src = ./.;
            doCheck = true;
            cargoBuildOptions = x: x ++ ["--no-default-features" "--features" "tcp"];
            cargoTestOptions  = x: x ++ ["--no-default-features" "--features" "tcp"];
          };
        };        
        devShell = with pkgs; mkShell {
          nativeBuildInputs = with pkgs; [rustc cargo rustfmt pre-commit clippy cargo-expand];
        };
      });
}